#include "csapp.h"
void echo(int connfd);

int main(int argc, char **argv)
{
    int listenfd, connfd;
    socklen_t clientlen;
    struct sockaddr_storage clientaddr; /* Large enough to accommodate all supported protocol-specific address structures */
    char client_hostname[MAXLINE], client_port[MAXLINE];

    // create a listening socket on the port passed in as a command-line argument
    listenfd = Open_listenfd(argv[1]);
    // loop forever, accepting connections from clients
    while (1)
    {
        clientlen = sizeof(struct sockaddr_storage); /* Need to tell Accept how big the clientaddr struct is */
        connfd = Accept(listenfd, (SA *)&clientaddr, &clientlen);

        // use getnameinfo library function to convert from clientaddr struct
        // to hostname and port strings
        Getnameinfo((SA *)&clientaddr, clientlen,
                    client_hostname, MAXLINE, client_port, MAXLINE, 0);
        printf("Connected to (%s, %s)\n", client_hostname, client_port);

        // call echo function, passing file descriptor for the socket connected to client
        echo(connfd);
        // close the connection
        Close(connfd);
    }
    exit(0);
}

void echo(int connfd) {
    size_t n;
    char buf[MAXLINE];
    rio_t rio;

    Rio_readinitb(&rio, connfd);
    while ((n = Rio_readlineb(&rio, buf, MAXLINE)) != 0) {
        printf("server received %ld bytes\n", n);
        Rio_writen(connfd, buf, n);
    }
}